/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 23 "parse.y" /* yacc.c:337  */

  #define _GNU_SOURCE

  #ifdef HAVE_CONFIG_H
  # include <config.h>
  #endif

  #include "python.h" // Should be included first

  #include <stdio.h>
  #include <stdlib.h>
  #include <stdarg.h>
  #include <string.h>
  #include <ctype.h>
  #include <assert.h>
  #include <errno.h> // For program_invocation_name

  #include "c2py.h"
  #include "llist.h"
  #include "input.h"

  #define TOKEN_STRING "()[]{},=<>+-/*?:!&|^.;" // Valid one-character tokens
  #define QUOTE_CHARS "\"'"

  /* Increment `num' and make sure it didn't wrap around, running
     `action' if it did */
  #define increment_action(num, action) do {				\
      if (!++(num)) {							\
	/* num has wrapped around to zero */				\
	fprintf(stderr, "%s: " __FILE__ ":" XSTR(__LINE__)		\
		": in %s(): " XSTR(num) " has overflowed\n",		\
		program_invocation_name, __func__);			\
	action;								\
      }									\
    } while (0)

  /* Make sure `num' is not 0, running `action' if it is, and
     decrement it */
  #define decrement_action(num, action) do {				\
      if (!(num)) {							\
	fprintf(stderr, "%s: " __FILE__ ":" XSTR(__LINE__)		\
		": in %s(): tried to decrement " XSTR(num)		\
		" below zero\n", program_invocation_name, __func__);	\
	action;								\
      }									\
									\
      (num)--;								\
    } while (0)

  /* These are for use in bison symbols */
  #define increment(num) increment_action(num, YYABORT)
  #define decrement(num) decrement_action(num, YYABORT)

  /* These are for use in yylex() */
  #define yylex_increment(num)						\
    increment_action(num, if (input_chars) llist_destroy(input_chars);	\
			  return YYLEX_ERROR)
  #define yylex_decrement(num)						\
    decrement_action(num, if (input_chars) llist_destroy(input_chars);	\
			  return YYLEX_ERROR)

  /* Add a new element to `empty_block' and set it to 1. */
  #define next_empty() do {			\
      if (empty_block) {			\
	llist_add_forward(empty_block);		\
	llist_next(empty_block);		\
      }						\
      else {					\
	llist_create(empty_block);		\
      }						\
						\
      empty_block->data = 1;			\
    } while (0)

  /* Set the current `empty_block' to 1 (used in `case' and
     `default'). */
  #define empty()				\
    if (empty_block)				\
      empty_block->data = 1
  
  /* Set the current element of `empty_block' to 0. */
  #define not_empty()				\
    if (empty_block)				\
      empty_block->data = 0

  /* Set the previous element of `empty_block' to 0. */
  #define prev_not_empty()			\
    if (empty_block && empty_block->prev)	\
      empty_block->prev->data = 0

  /* Set the previous previous element of `empty_block to 0. */
  #define prev_prev_not_empty()						\
    if (empty_block && empty_block->prev && empty_block->prev->prev)	\
      empty_block->prev->prev->data = 0

  /* Pop the last `empty_block'. */
  #define pop_empty() do {			\
      if (empty_block) {			\
	if (empty_block->prev) {		\
	  llist_prev(empty_block);		\
	  llist_remove(empty_block->next);	\
	}					\
	else {					\
	  llist_remove(empty_block);		\
	  empty_block = NULL;			\
	}					\
      }						\
    } while (0)

  /* Add a new element to a linked list */
  #define list_add_new(list, type) do {		\
      if (list) {				\
	type *new = malloc(sizeof(*new));	\
	new->prev = (list);			\
	(list) = new;				\
      }						\
      else {					\
	(list) = malloc(sizeof(*(list)));	\
	(list)->prev = NULL;			\
      }						\
    } while (0)

  /* Free an element from a linked list */
  #define list_free(list, type) do {		\
      type *old = (list);			\
      (list) = (list)->prev;			\
      free(old);				\
    } while (0)

  /* Add a new element to a doubly linked list */
  #define dlist_add_new(list) do {			\
      if (list) {					\
	(list)->next = malloc(sizeof(*((list)->next)));	\
	(list)->next->prev = (list);			\
	(list) = (list)->next;				\
	(list)->next = NULL;				\
      }							\
      else {						\
	(list) = malloc(sizeof(*(list)));		\
	(list)->prev = (list)->next = NULL;		\
      }							\
    } while (0)

  /* Free an element from a doubly linked list */
  #define dlist_free(list) do {			\
      if ((list)->prev) {			\
	(list) = (list)->prev;			\
	free((list)->next);			\
	(list)->next = NULL;			\
      }						\
      else {					\
	free(list);				\
	(list) = NULL;				\
      }						\
    } while (0)

  /* We have to define this here because we can't use preprocessor
     directives in the grammer rules section. */
  #define inc_indent_if_interactive()		\
    if (interactive) increment(indent_count)
  #define dec_indent_if_interactive()		\
    if (interactive) decrement(indent_count)

  struct backtrace {
    struct backtrace *prev, *next;
    enum { class, func, method } type;
    char *name;
    unsigned int line, column, indent_count;
  };

  struct quoted_pos {
    struct quoted_pos *prev;
    size_t start, end;
  };

  struct str_list {
    struct str_list *prev;
    char *str;
  };
 
  static void yyerror(const char *);
  static int yylex(void);
  static int indent(const char *, char *, size_t, size_t *);
  #ifndef HAVE_LIBPYTHON
  /* If we're compiled without libpython3, this will not be defined in
     input.h. */
  static int output(const char *, ...);
  #endif

  /* This is for error handling. */
  static unsigned int last_line = 1, last_column = 1,
    line = 1, column = 0, column_save;
  static unsigned int do_count = 0;
  /* What to put at the end of a while loop */
  static struct str_list *while_end_expr = NULL;
  /* Keep track of the backtrace for error reporting. */
  static struct backtrace *backtrace = NULL;
  static struct indent_count
    /* This is used for C style for loops. See the `block_end' and
     `for' symbols. */
    *while_indent_count = NULL,
    *switch_indent_count = NULL;
  /* Positions between which we should not indent because they are
     quoted. */
  static struct quoted_pos *quoted_pos = NULL;
  static char output_no_indent = 0;
  /* Whether to output "pass" if we recieved an empty block. */
  static llist_t *empty_block = NULL;

#line 280 "parse.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_PARSE_H_INCLUDED
# define YY_YY_PARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 0,
    STRING = 258,
    STRING_LITERAL = 259,
    IMPORT = 260,
    FROM = 261,
    AS = 262,
    DO = 263,
    WHILE = 264,
    FOR = 265,
    IN = 266,
    IF = 267,
    ELSE = 268,
    ELIF = 269,
    SWITCH = 270,
    CASE = 271,
    DEFAULT = 272,
    TRY = 273,
    EXCEPT = 274,
    FINALLY = 275,
    RAISE = 276,
    POWER = 277,
    INT_DIV = 278,
    PLUS_EQ = 279,
    MINUS_EQ = 280,
    MUL_EQ = 281,
    DIV_EQ = 282,
    LESS_EQ = 283,
    GREATER_EQ = 284,
    EQUAL = 285,
    NOT_EQUAL = 286,
    BOOL_AND = 287,
    BOOL_OR = 288,
    DEL = 289,
    GLOBAL = 290,
    CLASS = 291,
    RETURN = 292,
    YYLEX_ERROR = 293
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 241 "parse.y" /* yacc.c:352  */

  char *string, *static_string, *opt_string;
  char bool;

#line 368 "parse.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSE_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   947

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  61
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  46
/* YYNRULES -- Number of rules.  */
#define YYNRULES  134
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  225

#define YYUNDEFTOK  2
#define YYMAXUTOK   293

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    59,     2,     2,     2,     2,    52,     2,
      40,    41,    47,    45,    60,    46,    55,    48,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    42,    39,
      50,    49,    51,    58,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    56,     2,    57,    54,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    43,    53,    44,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   327,   327,   331,   332,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   364,   365,   366,
     367,   372,   373,   374,   383,   384,   394,   395,   403,   404,
     416,   421,   427,   433,   442,   450,   480,   481,   496,   525,
     526,   527,   531,   541,   555,   595,   611,   624,   640,   653,
     663,   672,   682,   696,   707,   723,   770,   783,   818,   818,
     849,   873,   906,   936,   962,   963,   975,   976,   979,   982,
     991,   996,  1025,  1038,  1051,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1161,  1162,  1165,
    1169,  1170,  1182,  1183,  1195,  1195,  1198,  1201,  1205,  1206,
    1208,  1217,  1226,  1236,  1250,  1259,  1269,  1279,  1297,  1307,
    1316,  1326,  1336,  1348,  1361,  1369,  1379,  1393,  1405,  1417,
    1420,  1428,  1438,  1439,  1452
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "$undefined", "\"name\"",
  "\"string literal\"", "\"import\"", "\"from\"", "\"as\"", "\"do\"",
  "\"while\"", "\"for\"", "\"in\"", "\"if\"", "\"else\"", "\"elif\"",
  "\"switch\"", "\"case\"", "\"default\"", "\"try\"", "\"except\"",
  "\"finally\"", "\"raise\"", "\"**\"", "\"//\"", "\"+=\"", "\"-*\"",
  "\"*=\"", "\"/=\"", "\"<=\"", "\">=\"", "\"==\"", "\"!=\"", "\"&&\"",
  "\"||\"", "\"del\"", "\"global\"", "\"class\"", "\"return\"",
  "YYLEX_ERROR", "';'", "'('", "')'", "':'", "'{'", "'}'", "'+'", "'-'",
  "'*'", "'/'", "'='", "'<'", "'>'", "'&'", "'|'", "'^'", "'.'", "'['",
  "']'", "'?'", "'!'", "','", "$accept", "start", "input", "input_real",
  "string_literal", "import", "func_call", "func_def", "inheritance",
  "class_def", "conditional_start_real", "conditional_start",
  "while_start", "do_end_while", "sline_conditional", "conditional",
  "sline_while", "while", "for_start", "do_start", "else_start",
  "sline_else", "else", "sline_for", "for", "sline_do", "$@1", "do",
  "switch", "case", "except_expr", "try_finally", "except", "try_except",
  "block_start", "block_end", "operation", "sign", "varname", "opt_from",
  "args_or_expr", "opt_expr", "expr", "args", "args_real", "yylex_error", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    59,
      40,    41,    58,   123,   125,    43,    45,    42,    47,    61,
      60,    62,    38,   124,    94,    46,    91,    93,    63,    33,
      44
};
# endif

#define YYPACT_NINF -97

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-97)))

#define YYTABLE_NINF -29

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -97,    12,   198,   -97,   -97,   -25,   889,    10,    15,   -97,
     -97,   -97,   -97,    16,   -97,   -13,   247,   -10,   -97,   -97,
     -97,   247,   247,   247,    26,   247,   -97,   247,   -97,   -97,
     -97,   -97,   247,   247,   -97,    30,   -97,   -97,   -97,   -97,
     -97,    -5,    -4,   -97,   -97,   -97,   -97,   -97,    -3,   224,
     224,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   224,
     247,   -97,   -97,   247,     7,   381,   -97,   247,    -1,    34,
     -97,   247,   -97,   -97,   427,   -97,   285,   843,   843,   -18,
       4,   -97,   843,   473,     5,   -15,    -8,   843,    30,   247,
     247,   247,   -97,   -97,   519,   -97,    11,   -97,    13,   224,
     -97,   335,   843,     8,    48,   247,   -97,   -97,   -97,   -97,
     -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   247,
     -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,
      50,   247,   247,   247,    22,    61,   -97,    63,   565,   -97,
     247,   -97,   247,   247,    24,   -97,   -97,   247,   -97,   611,
     657,     0,    29,   -97,   -97,   -97,   -97,    31,    68,   247,
     -97,   -97,   843,   -18,    33,   -32,   703,   751,   843,   -17,
      36,     2,    24,   843,   -18,    35,   -97,   224,    56,   247,
     247,    69,   -97,   -97,   843,   -97,   247,   -97,   247,   -97,
     -97,   -97,    76,   -97,   -97,   -97,   -97,    41,   -97,   -97,
      42,    44,    43,    32,    45,   843,    55,   -97,   -97,   224,
     247,   247,   -97,   -97,   -97,    58,    57,   797,   -97,   224,
      65,   -97,    66,   -97,   -97
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     1,    27,   100,    25,     0,     0,    50,
      43,    49,    39,    51,    41,     0,     0,     0,    66,    68,
      67,   117,     0,     0,     0,   106,   134,   129,    74,    97,
      98,    99,   129,     0,     4,   109,     5,     6,     7,     8,
      42,     0,     0,    16,    11,    17,    12,    18,     0,     0,
     106,    13,    19,     9,    14,    10,    15,    20,    21,   106,
     106,    22,    24,     0,   108,     0,    26,   129,     0,     0,
      40,     0,   100,    28,     0,    63,   102,   114,   132,   116,
      36,   115,   107,   132,     0,   130,     0,   128,    29,     0,
       0,   106,    73,    60,     0,    53,     0,    70,     0,   106,
      64,   107,   124,   113,     0,     0,    89,    90,    85,    86,
      87,    88,    91,    92,    94,    93,    95,    96,    23,   129,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
       0,     0,     0,     0,     0,     0,    30,     0,     0,    62,
       0,   118,     0,   129,     0,   119,   111,   131,   110,     0,
       0,   108,     0,    58,    52,    69,    72,     0,     0,     0,
     101,   125,   105,   104,     0,   121,     0,     0,   123,     0,
       0,     0,     0,   103,   133,     0,    38,   106,     0,     0,
     106,     0,    71,    65,   126,   120,   129,   112,     0,    34,
      35,    31,     0,    32,    61,    37,    46,     0,    44,    48,
       0,     0,     0,     0,     0,   127,     0,    45,    47,   106,
     106,     0,   122,    33,    56,     0,     0,     0,    54,   106,
       0,    57,     0,    59,    55
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -97,   -97,   -97,   -97,   -34,   -97,   -97,   -97,   -97,   -97,
     -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,
     -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,   -97,
     -97,   -97,   -97,   -97,   -26,   -97,   -97,   -97,   -87,   -97,
     -96,   -43,    -2,   -27,   -21,   -97
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    34,    35,    36,    37,    38,   144,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,   181,    56,    57,    58,
      99,    59,    60,    61,    93,    62,   133,    63,    64,   141,
     161,    81,    82,    84,    85,    66
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      65,    88,    79,   103,   151,    86,   135,    96,   186,   192,
     103,   179,     3,    68,    74,    67,    98,   100,    69,    76,
      77,    78,   189,   104,    95,    83,    92,    71,    70,    80,
      78,    87,    75,    97,    73,    89,    90,    91,   136,   137,
     134,   193,   142,   165,   143,   147,   146,    94,   152,   148,
     154,   160,   155,    72,    88,   104,   157,   159,   101,    72,
      73,   102,   104,   169,   170,    78,   171,    92,   180,   138,
     182,   183,   211,   156,   185,   191,   195,    21,   203,   206,
     207,   208,   210,   201,   163,   209,   212,   149,   150,     0,
      22,    23,   164,    25,   213,   198,    27,   218,   219,    92,
       0,    29,    30,   162,   223,   224,     0,     0,     0,     0,
       0,    31,    32,     0,     0,    33,   175,    78,   176,     0,
       0,   174,     0,     0,     0,     0,   174,     0,     0,   166,
     167,   168,     0,     0,   197,   200,     0,   202,   173,     0,
      78,    78,     0,   190,     0,    78,   194,     0,     0,     0,
       0,   196,   199,     0,     0,     0,     0,   184,   163,   204,
       0,     0,     0,     0,     0,     0,   215,   216,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   162,     0,     0,
       0,     0,     0,   214,    78,     0,   205,     0,     0,     0,
       0,     0,     0,   221,     0,     0,     0,     0,    -2,     4,
       0,     5,     6,     7,     8,     0,     9,    10,    11,   217,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
       0,     0,     0,     0,     0,     0,     0,    72,    73,     0,
       0,     0,    22,    23,    24,    25,    26,     0,    27,     0,
       0,     0,    28,    29,    30,    21,     0,     0,     0,     0,
      72,    73,     0,    31,    32,     0,     0,    33,    22,    23,
       0,    25,     0,     0,    27,     0,     0,    92,    21,    29,
      30,     0,     0,     0,     0,     0,     0,     0,     0,    31,
      32,    22,    23,    33,    25,     0,     0,    27,     0,     0,
       0,   140,    29,    30,     0,     0,   105,     0,     0,     0,
       0,     0,    31,    32,     0,     0,    33,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
       0,     0,     0,     0,     0,   119,     0,     0,     0,     0,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   158,   132,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
       0,     0,     0,     0,     0,   119,     0,     0,     0,     0,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   105,   132,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,     0,     0,     0,     0,
     118,   119,     0,     0,     0,     0,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   105,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,     0,     0,     0,   119,     0,   139,
       0,     0,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   105,   132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,     0,     0,     0,
       0,     0,     0,   119,   145,     0,     0,     0,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     105,   132,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,     0,     0,     0,     0,     0,   153,   119,
       0,     0,     0,     0,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   105,   132,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
       0,     0,     0,     0,     0,   119,   172,     0,     0,     0,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   105,   132,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,     0,     0,     0,     0,
       0,   119,   177,     0,     0,     0,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   105,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,     0,     0,     0,   119,   178,     0,
       0,     0,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   105,   132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,     0,     0,     0,
       0,     0,     0,   119,     0,     0,     0,     0,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     187,   132,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,     0,     0,     0,     0,
       0,   119,     0,   188,     0,     0,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   105,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,     0,     0,     0,   119,   220,     0,
       0,     0,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   105,   132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,     0,     0,     0,
       0,     0,     0,   119,     0,     0,     0,     0,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     -28,   132,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,
     -28,   -28,   -28,     0,     0,     0,     0,     0,   -28,     0,
       0,     0,     0,     0,     0,     0,   -28,   -28,   -28,   -28,
     -28,   -28,   -28,   -28,     0,     0,     0,   -28
};

static const yytype_int16 yycheck[] =
{
       2,    35,    23,     3,    91,    32,     7,    50,    40,     7,
       3,    11,     0,     3,    16,    40,    59,    60,     3,    21,
      22,    23,    39,    55,    50,    27,    43,    40,    12,     3,
      32,    33,    42,    59,     4,    40,    40,    40,    39,     5,
      67,    39,    60,   130,    40,    60,    41,    49,    91,    57,
      39,     3,    39,     3,    88,    55,    99,    49,    60,     3,
       4,    63,    55,    41,     3,    67,     3,    43,    39,    71,
      39,     3,    40,    99,    41,    39,    41,    21,     9,     3,
      39,    39,    39,   179,   105,    41,    41,    89,    90,    -1,
      34,    35,   119,    37,    39,    39,    40,    39,    41,    43,
      -1,    45,    46,   105,    39,    39,    -1,    -1,    -1,    -1,
      -1,    55,    56,    -1,    -1,    59,   143,   119,   144,    -1,
      -1,   142,    -1,    -1,    -1,    -1,   147,    -1,    -1,   131,
     132,   133,    -1,    -1,   177,   178,    -1,   180,   140,    -1,
     142,   143,    -1,   169,    -1,   147,   172,    -1,    -1,    -1,
      -1,   177,   178,    -1,    -1,    -1,    -1,   159,   179,   186,
      -1,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   219,   179,    -1,    -1,
      -1,    -1,    -1,   209,   186,    -1,   188,    -1,    -1,    -1,
      -1,    -1,    -1,   219,    -1,    -1,    -1,    -1,     0,     1,
      -1,     3,     4,     5,     6,    -1,     8,     9,    10,   211,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,
      -1,    -1,    34,    35,    36,    37,    38,    -1,    40,    -1,
      -1,    -1,    44,    45,    46,    21,    -1,    -1,    -1,    -1,
       3,     4,    -1,    55,    56,    -1,    -1,    59,    34,    35,
      -1,    37,    -1,    -1,    40,    -1,    -1,    43,    21,    45,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      56,    34,    35,    59,    37,    -1,    -1,    40,    -1,    -1,
      -1,     6,    45,    46,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    55,    56,    -1,    -1,    59,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,     7,    58,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    11,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    11,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    42,
      -1,    -1,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    11,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      11,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    11,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    11,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    -1,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    11,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,
      -1,    -1,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    11,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    42,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    11,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,
      -1,    -1,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    11,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      11,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    58
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    62,    63,     0,     1,     3,     4,     5,     6,     8,
       9,    10,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    34,    35,    36,    37,    38,    40,    44,    45,
      46,    55,    56,    59,    64,    65,    66,    67,    68,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    88,    89,    90,    92,
      93,    94,    96,    98,    99,   103,   106,    40,     3,     3,
      12,    40,     3,     4,   103,    42,   103,   103,   103,   105,
       3,   102,   103,   103,   104,   105,   104,   103,    65,    40,
      40,    40,    43,    95,   103,    95,   102,    95,   102,    91,
     102,   103,   103,     3,    55,    11,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    39,    40,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    58,    97,   104,     7,    39,     5,   103,    42,
       6,   100,    60,    40,    69,    41,    41,    60,    57,   103,
     103,    99,   102,    39,    39,    39,    95,   102,     7,    49,
       3,   101,   103,   105,   104,    99,   103,   103,   103,    41,
       3,     3,    41,   103,   105,   104,    95,    41,    41,    11,
      39,    87,    39,     3,   103,    41,    40,    57,    42,    39,
      95,    39,     7,    39,    95,    41,    95,   102,    39,    95,
     102,   101,   102,     9,   104,   103,     3,    39,    39,    41,
      39,    40,    41,    39,    95,   102,   102,   103,    39,    41,
      41,    95,   102,    39,    39
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    61,    62,    63,    63,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    65,    65,
      66,    66,    66,    66,    67,    68,    69,    69,    70,    71,
      71,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    84,    85,    85,    87,    86,
      88,    89,    90,    90,    91,    91,    92,    92,    93,    94,
      94,    94,    94,    95,    96,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    97,    97,    98,    98,    98,
      99,    99,   100,   100,   101,   101,   102,   102,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   104,
     104,   104,   105,   105,   106
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       3,     5,     5,     7,     5,     5,     0,     3,     4,     1,
       2,     1,     1,     1,     5,     6,     5,     6,     5,     1,
       1,     1,     3,     2,     8,    10,     7,     9,     0,     9,
       2,     5,     3,     2,     1,     3,     1,     1,     1,     3,
       2,     4,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     0,     2,     1,     1,     0,     1,     1,     1,
       3,     3,     4,     2,     2,     2,     2,     1,     3,     3,
       4,     3,     6,     3,     2,     3,     4,     5,     2,     0,
       1,     2,     1,     3,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
    case 3: /* "name"  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1518 "parse.c" /* yacc.c:1257  */
        break;

    case 4: /* "string literal"  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1524 "parse.c" /* yacc.c:1257  */
        break;

    case 65: /* string_literal  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1530 "parse.c" /* yacc.c:1257  */
        break;

    case 69: /* inheritance  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1536 "parse.c" /* yacc.c:1257  */
        break;

    case 91: /* except_expr  */
#line 317 "parse.y" /* yacc.c:1257  */
      { if (*((*yyvaluep).opt_string)) free(((*yyvaluep).opt_string)); }
#line 1542 "parse.c" /* yacc.c:1257  */
        break;

    case 99: /* varname  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1548 "parse.c" /* yacc.c:1257  */
        break;

    case 100: /* opt_from  */
#line 317 "parse.y" /* yacc.c:1257  */
      { if (*((*yyvaluep).opt_string)) free(((*yyvaluep).opt_string)); }
#line 1554 "parse.c" /* yacc.c:1257  */
        break;

    case 101: /* args_or_expr  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1560 "parse.c" /* yacc.c:1257  */
        break;

    case 102: /* opt_expr  */
#line 317 "parse.y" /* yacc.c:1257  */
      { if (*((*yyvaluep).opt_string)) free(((*yyvaluep).opt_string)); }
#line 1566 "parse.c" /* yacc.c:1257  */
        break;

    case 103: /* expr  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1572 "parse.c" /* yacc.c:1257  */
        break;

    case 104: /* args  */
#line 317 "parse.y" /* yacc.c:1257  */
      { if (*((*yyvaluep).opt_string)) free(((*yyvaluep).opt_string)); }
#line 1578 "parse.c" /* yacc.c:1257  */
        break;

    case 105: /* args_real  */
#line 316 "parse.y" /* yacc.c:1257  */
      { free(((*yyvaluep).string)); }
#line 1584 "parse.c" /* yacc.c:1257  */
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 319 "parse.y" /* yacc.c:1431  */
{
		  indent_count = wait_string = switch_count = 0;
		  do_indent_count = NULL;
		}

#line 1674 "parse.c" /* yacc.c:1431  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 327 "parse.y" /* yacc.c:1652  */
    { end_conditional(); }
#line 1860 "parse.c" /* yacc.c:1652  */
    break;

  case 4:
#line 332 "parse.y" /* yacc.c:1652  */
    {
		  /* End a do-while loop and abort if we're not in
		     interactive mode and the symbol wasn't
		     `block_end' (if it was `block_end', $2 will be
		     1). */
		  if (!(yyvsp[0].bool) && do_indent_count &&
		      do_indent_count->count == indent_count) {
		    list_free(do_indent_count, struct indent_count);

		    yyerror("syntax error, expected `while' to end `do'");
		    if (!interactive) YYABORT;
		  }
		}
#line 1878 "parse.c" /* yacc.c:1652  */
    break;

  case 5:
#line 347 "parse.y" /* yacc.c:1652  */
    { end_conditional(); not_empty(); (yyval.bool) = 0; }
#line 1884 "parse.c" /* yacc.c:1652  */
    break;

  case 6:
#line 348 "parse.y" /* yacc.c:1652  */
    { end_conditional(); not_empty(); (yyval.bool) = 0; }
#line 1890 "parse.c" /* yacc.c:1652  */
    break;

  case 7:
#line 349 "parse.y" /* yacc.c:1652  */
    { end_conditional(); prev_not_empty(); (yyval.bool) = 0; }
#line 1896 "parse.c" /* yacc.c:1652  */
    break;

  case 8:
#line 350 "parse.y" /* yacc.c:1652  */
    { end_conditional(); prev_not_empty(); (yyval.bool) = 0; }
#line 1902 "parse.c" /* yacc.c:1652  */
    break;

  case 9:
#line 351 "parse.y" /* yacc.c:1652  */
    { not_empty(); (yyval.bool) = 0; }
#line 1908 "parse.c" /* yacc.c:1652  */
    break;

  case 10:
#line 352 "parse.y" /* yacc.c:1652  */
    { end_conditional(); not_empty(); (yyval.bool) = 0; }
#line 1914 "parse.c" /* yacc.c:1652  */
    break;

  case 11:
#line 353 "parse.y" /* yacc.c:1652  */
    { not_empty(); (yyval.bool) = 0; }
#line 1920 "parse.c" /* yacc.c:1652  */
    break;

  case 12:
#line 354 "parse.y" /* yacc.c:1652  */
    { not_empty(); (yyval.bool) = 0; }
#line 1926 "parse.c" /* yacc.c:1652  */
    break;

  case 13:
#line 355 "parse.y" /* yacc.c:1652  */
    { not_empty(); (yyval.bool) = 0; }
#line 1932 "parse.c" /* yacc.c:1652  */
    break;

  case 14:
#line 356 "parse.y" /* yacc.c:1652  */
    { prev_not_empty(); (yyval.bool) = 0; }
#line 1938 "parse.c" /* yacc.c:1652  */
    break;

  case 15:
#line 357 "parse.y" /* yacc.c:1652  */
    { prev_not_empty(); (yyval.bool) = 0; }
#line 1944 "parse.c" /* yacc.c:1652  */
    break;

  case 16:
#line 358 "parse.y" /* yacc.c:1652  */
    {
		  (yyval.bool) = 0;
		  prev_prev_not_empty();
		  /* Yes, you read that right. That's two
		     `prev's. Please don't ask me why. */
		}
#line 1955 "parse.c" /* yacc.c:1652  */
    break;

  case 17:
#line 364 "parse.y" /* yacc.c:1652  */
    { prev_not_empty(); (yyval.bool) = 0; }
#line 1961 "parse.c" /* yacc.c:1652  */
    break;

  case 18:
#line 365 "parse.y" /* yacc.c:1652  */
    { prev_not_empty(); (yyval.bool) = 0; }
#line 1967 "parse.c" /* yacc.c:1652  */
    break;

  case 19:
#line 366 "parse.y" /* yacc.c:1652  */
    { prev_not_empty(); (yyval.bool) = 0; }
#line 1973 "parse.c" /* yacc.c:1652  */
    break;

  case 20:
#line 367 "parse.y" /* yacc.c:1652  */
    {
		  (yyval.bool) = 0;
		  end_conditional();
		  prev_prev_not_empty(); // Yep, again
		}
#line 1983 "parse.c" /* yacc.c:1652  */
    break;

  case 21:
#line 372 "parse.y" /* yacc.c:1652  */
    { end_conditional(); prev_not_empty(); (yyval.bool) = 0; }
#line 1989 "parse.c" /* yacc.c:1652  */
    break;

  case 22:
#line 373 "parse.y" /* yacc.c:1652  */
    { prev_not_empty(); (yyval.bool) = 0; }
#line 1995 "parse.c" /* yacc.c:1652  */
    break;

  case 23:
#line 374 "parse.y" /* yacc.c:1652  */
    {
		  (yyval.bool) = 0;
		  end_conditional();
		  
		  output("%s\n", (yyvsp[-1].string));
		  free((yyvsp[-1].string));

		  not_empty();
		}
#line 2009 "parse.c" /* yacc.c:1652  */
    break;

  case 24:
#line 383 "parse.y" /* yacc.c:1652  */
    { (yyval.bool) = 1; }
#line 2015 "parse.c" /* yacc.c:1652  */
    break;

  case 25:
#line 384 "parse.y" /* yacc.c:1652  */
    {
		  (yyval.bool) = 0;

		  if (!minify)
		    output("%s\n", (yyvsp[0].string));

		  free((yyvsp[0].string));

		  not_empty();
		}
#line 2030 "parse.c" /* yacc.c:1652  */
    break;

  case 26:
#line 394 "parse.y" /* yacc.c:1652  */
    { (yyval.bool) = 0; }
#line 2036 "parse.c" /* yacc.c:1652  */
    break;

  case 27:
#line 395 "parse.y" /* yacc.c:1652  */
    {
		  if (interactive)
		    (yyval.bool) = 0;
		  else
		    YYABORT;
		}
#line 2047 "parse.c" /* yacc.c:1652  */
    break;

  case 29:
#line 404 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-1].string)) + strlen((yyvsp[0].string)) + (minify ? 1 : 2));

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, minify ? "%s%s" : "%s %s", (yyvsp[-1].string), (yyvsp[0].string));

		  free((yyvsp[-1].string));
		  free((yyvsp[0].string));
		}
#line 2062 "parse.c" /* yacc.c:1652  */
    break;

  case 30:
#line 416 "parse.y" /* yacc.c:1652  */
    {
		  output("import %s\n", (yyvsp[-1].string));

		  free((yyvsp[-1].string));
		}
#line 2072 "parse.c" /* yacc.c:1652  */
    break;

  case 31:
#line 421 "parse.y" /* yacc.c:1652  */
    {
		  output("import %s as %s\n", (yyvsp[-3].string), (yyvsp[-1].string));

		  free((yyvsp[-3].string));
		  free((yyvsp[-1].string));
		}
#line 2083 "parse.c" /* yacc.c:1652  */
    break;

  case 32:
#line 427 "parse.y" /* yacc.c:1652  */
    {
		  output("from %s import %s\n", (yyvsp[-3].string), (yyvsp[-1].string));

		  free((yyvsp[-3].string));
		  free((yyvsp[-1].string));
		}
#line 2094 "parse.c" /* yacc.c:1652  */
    break;

  case 33:
#line 433 "parse.y" /* yacc.c:1652  */
    {
		  output("from %s import %s as %s\n", (yyvsp[-5].string), (yyvsp[-3].string), (yyvsp[-1].string));

		  free((yyvsp[-5].string));
		  free((yyvsp[-3].string));
		  free((yyvsp[-1].string));
		}
#line 2106 "parse.c" /* yacc.c:1652  */
    break;

  case 34:
#line 442 "parse.y" /* yacc.c:1652  */
    {
		  output("%s(%s)\n", (yyvsp[-4].string), (yyvsp[-2].opt_string));

		  free((yyvsp[-4].string));
		  if (*(yyvsp[-2].opt_string)) free((yyvsp[-2].opt_string));
		}
#line 2117 "parse.c" /* yacc.c:1652  */
    break;

  case 35:
#line 450 "parse.y" /* yacc.c:1652  */
    {
		  output("def %s(%s):\n", (yyvsp[-4].string), (yyvsp[-2].opt_string));

		  if (*(yyvsp[-2].opt_string)) free((yyvsp[-2].opt_string));

		  /* Add the function to the backtrace. */
		  if (backtrace) {
		    backtrace->next = malloc(sizeof(*backtrace));
		    backtrace->next->prev = backtrace;
		    backtrace = backtrace->next;
		    backtrace->next = NULL;
		    backtrace->type = (backtrace->prev->type == class) ?
		      method : func;
		  }
		  else {
		    backtrace = malloc(sizeof(*backtrace));
		    backtrace->prev = NULL;
		    backtrace->next = NULL;
		    backtrace->type = func;
		  }
		  backtrace->name = (yyvsp[-4].string);
		  backtrace->indent_count = indent_count;
		  backtrace->line = last_line;
		  backtrace->column = last_column;

		  increment(indent_count);
		}
#line 2149 "parse.c" /* yacc.c:1652  */
    break;

  case 36:
#line 480 "parse.y" /* yacc.c:1652  */
    { (yyval.string) = ""; }
#line 2155 "parse.c" /* yacc.c:1652  */
    break;

  case 37:
#line 481 "parse.y" /* yacc.c:1652  */
    {
		  if (*(yyvsp[-1].opt_string)) {
		    size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-1].opt_string)) + 3);

		    (yyval.string) = malloc(size);
		    snprintf((yyval.string), size, "(%s)", (yyvsp[-1].opt_string));

		    free((yyvsp[-1].opt_string));
		  }
		  else {
		    (yyval.string) = "";
		  }
		}
#line 2173 "parse.c" /* yacc.c:1652  */
    break;

  case 38:
#line 496 "parse.y" /* yacc.c:1652  */
    {
		  output("class %s%s%s:\n",
			 (yyvsp[-2].string), (!minify && *(yyvsp[-1].string)) ? " " : "", (yyvsp[-1].string));

		  if (*(yyvsp[-1].string)) free((yyvsp[-1].string));

		  /* Add the class to the backtrace. */
		  if (backtrace) {
		    backtrace->next = malloc(sizeof(*backtrace));
		    backtrace->next->prev = backtrace;
		    backtrace = backtrace->next;
		    backtrace->next = NULL;
		  }
		  else {
		    backtrace = malloc(sizeof(*backtrace));
		    backtrace->prev = NULL;
		    backtrace->next = NULL;
		  }
		  backtrace->type = class;
		  backtrace->name = (yyvsp[-2].string);
		  backtrace->indent_count = indent_count;
		  backtrace->line = last_line;
		  backtrace->column = last_column;

		  increment(indent_count);
		}
#line 2204 "parse.c" /* yacc.c:1652  */
    break;

  case 39:
#line 525 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "if"; }
#line 2210 "parse.c" /* yacc.c:1652  */
    break;

  case 40:
#line 526 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "elif"; }
#line 2216 "parse.c" /* yacc.c:1652  */
    break;

  case 41:
#line 527 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "elif"; }
#line 2222 "parse.c" /* yacc.c:1652  */
    break;

  case 42:
#line 531 "parse.y" /* yacc.c:1652  */
    {
		  if (!indent_count)
		    wait_string = 1;

		  /* Increment `indent_count' so the prompt will be
		     properly indented. */
		  inc_indent_if_interactive();
		}
#line 2235 "parse.c" /* yacc.c:1652  */
    break;

  case 43:
#line 541 "parse.y" /* yacc.c:1652  */
    {
		  /* Only do stuff if we're not ending a `do' loop */
		  if (!do_indent_count ||
		      do_indent_count->count != indent_count) {
		    if (!indent_count)
		      wait_string = 1;

		    /* Increment `indent_count' so the prompt will be
		       properly indented. */
		    inc_indent_if_interactive();
		  }
		}
#line 2252 "parse.c" /* yacc.c:1652  */
    break;

  case 44:
#line 555 "parse.y" /* yacc.c:1652  */
    {
		  /* Check if we're actually ending a `do' */
		  if (do_indent_count &&
		      do_indent_count->count == indent_count) {
		    decrement(do_count);

		    if (wait_string == 1)
		      wait_string = 0;

		    list_free(do_indent_count, struct indent_count);

		    /* Output the while expression */
		    output("while __c2py_do_%1$u or (%2$s):\n"
			   "%3$s__c2py_do_%1$u%4$s\n",
			   do_count, (yyvsp[-2].string), indent_string,
			   minify ? "=0" : " = False");

		    /* Clean up the temporary variable */
		    output("del __c2py_do_%u\n", do_count);
		  }
		  /* Otherwise, we're just a regular `while' without a
		     body */
		  else {
		    /* Decrement `indent_count' if we incremented it
		       for the prompt. */
		    dec_indent_if_interactive();

		    if (minify)
		      output("while %s:pass\n", (yyvsp[-2].string));
		    else
		      output("while %s:\n%spass\n", (yyvsp[-2].string), indent_string);
		  }

		  free((yyvsp[-2].string));
		}
#line 2292 "parse.c" /* yacc.c:1652  */
    break;

  case 45:
#line 595 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  if (minify)
		    output("%s %s:%s\n", (yyvsp[-5].static_string), (yyvsp[-3].string), *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		  else
		    output("%s %s:\n%s%s\n",
			   (yyvsp[-5].static_string), (yyvsp[-3].string), indent_string, *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");

		  free((yyvsp[-3].string));
		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 2311 "parse.c" /* yacc.c:1652  */
    break;

  case 46:
#line 611 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  output("%s %s:\n", (yyvsp[-4].static_string), (yyvsp[-2].string));

		  increment(indent_count);

		  free((yyvsp[-2].string));
		}
#line 2327 "parse.c" /* yacc.c:1652  */
    break;

  case 47:
#line 624 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  if (minify)
		    output("while %s:%s\n", (yyvsp[-3].string), *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		  else
		    output("while %s:\n%s%s\n",
			   (yyvsp[-3].string), indent_string, *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");

		  free((yyvsp[-3].string));
		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 2346 "parse.c" /* yacc.c:1652  */
    break;

  case 48:
#line 640 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  output("while %s:\n", (yyvsp[-2].string));

		  increment(indent_count);

		  free((yyvsp[-2].string));
		}
#line 2362 "parse.c" /* yacc.c:1652  */
    break;

  case 49:
#line 653 "parse.y" /* yacc.c:1652  */
    {
		  if (!indent_count)
		    wait_string = 1;

		  /* Increment `indent_count' so the prompt will be
		     properly indented. */
		  inc_indent_if_interactive();
		}
#line 2375 "parse.c" /* yacc.c:1652  */
    break;

  case 50:
#line 663 "parse.y" /* yacc.c:1652  */
    {
		  if (!indent_count)
		    wait_string = 1;

		  /* Increment `indent_count' so the prompt will be
		     properly indented. */
		  inc_indent_if_interactive();
		}
#line 2388 "parse.c" /* yacc.c:1652  */
    break;

  case 51:
#line 672 "parse.y" /* yacc.c:1652  */
    {
		  if (!indent_count)
		    wait_string = 1;

		  /* Increment `indent_count' so the prompt will be
		     properly indented. */
		  inc_indent_if_interactive();
		}
#line 2401 "parse.c" /* yacc.c:1652  */
    break;

  case 52:
#line 682 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  if (minify)
		    output("else:%s\n", *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		  else
		    output("else:\n%s%s\n", indent_string, *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");

		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 2418 "parse.c" /* yacc.c:1652  */
    break;

  case 53:
#line 696 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  output("else:\n");
		  increment(indent_count);
		}
#line 2431 "parse.c" /* yacc.c:1652  */
    break;

  case 54:
#line 707 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  if (minify)
		    output("for %s in %s:%s\n", (yyvsp[-5].string), (yyvsp[-3].string), *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		  else
		    output("for %s in %s:\n%s%s\n",
			   (yyvsp[-5].string), (yyvsp[-3].string), indent_string, *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");

		  free((yyvsp[-5].string));
		  free((yyvsp[-3].string));
		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 2451 "parse.c" /* yacc.c:1652  */
    break;

  case 55:
#line 724 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  if (*(yyvsp[-7].opt_string)) {
		    output("%s\n", (yyvsp[-7].opt_string));
		    free((yyvsp[-7].opt_string));
		  }

		  output("while %s:\n", *(yyvsp[-5].opt_string) ? (yyvsp[-5].opt_string) : "True");
		  
		  increment(indent_count);
		  
		  if (!(*(yyvsp[-3].opt_string) || *(yyvsp[-1].opt_string))) {
		    output("pass\n");
		  }
		  else if (minify) {
		    if (!(*(yyvsp[-1].opt_string) && *(yyvsp[-3].opt_string))) {
		      output("%s\n", *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : (yyvsp[-3].opt_string));
		    }
		    else {
		      output("%s\n%s\n", (yyvsp[-1].opt_string), (yyvsp[-3].opt_string));
		    }

		    if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		    if (*(yyvsp[-3].opt_string)) free((yyvsp[-3].opt_string));
		  }
		  else {
		    if (*(yyvsp[-1].opt_string)) {
		      output("%s\n", (yyvsp[-1].opt_string));
		      free((yyvsp[-1].opt_string));
		    }
		    if (*(yyvsp[-3].opt_string)) {
		      output("%s\n", (yyvsp[-3].opt_string));
		      free((yyvsp[-3].opt_string));
		    }
		  }

		  decrement(indent_count);
		  
		  if (*(yyvsp[-5].opt_string)) free((yyvsp[-5].opt_string));
		}
#line 2499 "parse.c" /* yacc.c:1652  */
    break;

  case 56:
#line 770 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  output("for %s in %s:\n", (yyvsp[-4].string), (yyvsp[-2].string));

		  increment(indent_count);

		  free((yyvsp[-4].string));
		  free((yyvsp[-2].string));
		}
#line 2516 "parse.c" /* yacc.c:1652  */
    break;

  case 57:
#line 784 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  if (*(yyvsp[-6].opt_string)) {
		    /* Run this first. `wait_string' will be 2 greater
		       than indent_count since it is incremented in
		       `for_start' and `block_start' (I think). */
		    decrement(wait_string);
		    decrement(wait_string);
		    output("%s\n", (yyvsp[-6].opt_string));
		    increment(wait_string);
		    increment(wait_string);

		    free((yyvsp[-6].opt_string));
		  }
	  
		  output("while %s:\n", *(yyvsp[-4].opt_string) ? (yyvsp[-4].opt_string) : "True");

		  increment(indent_count);
	    
		  if (*(yyvsp[-4].opt_string)) free((yyvsp[-4].opt_string));

		  if (*(yyvsp[-2].opt_string)) {
		    list_add_new(while_end_expr, struct str_list);
		    while_end_expr->str = (yyvsp[-2].opt_string);

		    list_add_new(while_indent_count, struct indent_count);
		    while_indent_count->count = indent_count;
		  }
		}
#line 2553 "parse.c" /* yacc.c:1652  */
    break;

  case 58:
#line 818 "parse.y" /* yacc.c:1652  */
    { dec_indent_if_interactive(); }
#line 2559 "parse.c" /* yacc.c:1652  */
    break;

  case 59:
#line 819 "parse.y" /* yacc.c:1652  */
    {
		  /* Set the `do' variable to True */
		  decrement(wait_string);
		  output("__c2py_do_%u%s\n",
			 do_count, minify ? "=1" : " = True");

		  output("while __c2py_do_%1$u or (%2$s):\n"
			 "%3$s__c2py_do_%1$u%4$s\n"
			 "%3$s%5$s\n"
#ifndef HAVE_LIBPYTHON
			 "del __c2py_do_%1$u\n"
#endif
			 ,
			 do_count, (yyvsp[-2].string), indent_string,
			 minify ? "=0" : " = False", (yyvsp[-7].string));

#ifdef HAVE_LIBPYTHON
		  /* This must be separate because we can't have a
		     statement directly after a `while' loop when
		     we're using libpython3 */
		  output("del __c2py_do_%u\n", do_count);
#endif

		  increment(wait_string);

		  free((yyvsp[-7].string));
		  free((yyvsp[-2].string));
		}
#line 2592 "parse.c" /* yacc.c:1652  */
    break;

  case 60:
#line 849 "parse.y" /* yacc.c:1652  */
    {
		  /* Decrement `indent_count' if we incremented it for
		     the prompt. */
		  dec_indent_if_interactive();

		  list_add_new(do_indent_count, struct indent_count);
		  do_indent_count->count = indent_count;

		  /* Set the `do' variable to True */
		  decrement(wait_string);
		  decrement(wait_string);
		  output("__c2py_do_%u%s\n",
			 do_count, minify ? "=1" : " = True");
		  increment(wait_string);
		  increment(wait_string);

		  increment(do_count);

		  increment(indent_count);
		}
#line 2617 "parse.c" /* yacc.c:1652  */
    break;

  case 61:
#line 873 "parse.y" /* yacc.c:1652  */
    {
		  list_add_new(switch_indent_count, struct indent_count);
		  switch_indent_count->count = indent_count;
		  
		  output("while %s:\n",
			 minify ? "1" : "True");
		  
		  increment(indent_count);
		  
		  output("__c2py_switch_val_%1$u%2$s%3$s\n"
			 "__c2py_switch_%1$u%4$s\n"
			 /* Don't execute anything until the first
			    `case' (which will automatically exit the
			    `if False'). This is the behavior of
			    switch statements in C. */
			 "if %5$s:\n",
			 switch_count, minify ? "=" : " = ", (yyvsp[-2].string),
			 minify ? "=0" : " = False\n",
			 minify ? "0" : "False");

		  free((yyvsp[-2].string));
		  
		  increment(switch_count);

		  increment(indent_count);

		  /* The `switch' block isn't empty... */
		  not_empty();
		  /* However, the `if False:' is (so far). */
		  next_empty();
		}
#line 2653 "parse.c" /* yacc.c:1652  */
    break;

  case 62:
#line 906 "parse.y" /* yacc.c:1652  */
    {
		  if (!switch_count) {
		    yyerror("syntax error, case outside of switch");

		    free((yyvsp[-1].string));
		    YYABORT;
		  }

		  /* Output "pass" here because we don't use
		     `block_end' to end the block. */
		  if (empty_block && empty_block->data)
		    output("pass\n");

		  /* Decrement to get out of the previous case
		     statement or the initial `if False'. */
		  decrement(indent_count);

		  output("if __c2py_switch_%1$u or "
			 "__c2py_switch_val_%1$u%2$s(%3$s):\n",
			 switch_count - 1, minify ? "==" : " == ", (yyvsp[-1].string));

		  free((yyvsp[-1].string));

		  increment(indent_count);

		  output("__c2py_switch_%u%s\n",
			 switch_count - 1, minify ? "=1" : " = True");

		  not_empty();
		}
#line 2688 "parse.c" /* yacc.c:1652  */
    break;

  case 63:
#line 936 "parse.y" /* yacc.c:1652  */
    {
		  if (!switch_count) {
		    yyerror("syntax error, default outside of switch");
		    YYABORT;
		  }

		  /* Output "pass" here because we don't use
		     `block_end' to end the block. */
		  if (empty_block->data)
		    output("pass\n");

		  /* Decrement to get out of the previous case
		     statement or the initial `if False'. */
		  decrement(indent_count);

		  output("if True:\n");

		  increment(indent_count);

		  output("__c2py_switch_%u%sTrue\n",
			 switch_count - 1, minify ? "=" : " = ");

		  not_empty();
		}
#line 2717 "parse.c" /* yacc.c:1652  */
    break;

  case 65:
#line 963 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.opt_string)) * (strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string)) + 5);

		  (yyval.opt_string) = malloc(size);
		  snprintf((yyval.opt_string), size, "%s as %s", (yyvsp[-2].string), (yyvsp[0].string));

		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 2731 "parse.c" /* yacc.c:1652  */
    break;

  case 66:
#line 975 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "try"; if (!indent_count) wait_string = 1; }
#line 2737 "parse.c" /* yacc.c:1652  */
    break;

  case 67:
#line 976 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "finally"; if (!indent_count) wait_string = 1; }
#line 2743 "parse.c" /* yacc.c:1652  */
    break;

  case 68:
#line 979 "parse.y" /* yacc.c:1652  */
    { if (!indent_count) wait_string = 1; }
#line 2749 "parse.c" /* yacc.c:1652  */
    break;

  case 69:
#line 982 "parse.y" /* yacc.c:1652  */
    {
		  if (minify)
		    output("%s:%s\n", (yyvsp[-2].static_string), *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		  else
		    output("%s:\n%s%s\n",
			   (yyvsp[-2].static_string), indent_string, *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");

		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 2763 "parse.c" /* yacc.c:1652  */
    break;

  case 70:
#line 991 "parse.y" /* yacc.c:1652  */
    {
		  output("%s:\n", (yyvsp[-1].static_string));

		  increment(indent_count);
		}
#line 2773 "parse.c" /* yacc.c:1652  */
    break;

  case 71:
#line 996 "parse.y" /* yacc.c:1652  */
    {
		  if (*(yyvsp[-2].opt_string)) {
		    if (*(yyvsp[-1].opt_string)) {
		      if (minify)
			output("except %s:%s\n", (yyvsp[-2].opt_string), (yyvsp[-1].opt_string));
		      else
			output("except %s:\n%s%s\n", (yyvsp[-2].opt_string), indent_string, (yyvsp[-1].opt_string));
		    }
		    else {
		      /* The user probably meant "except: $2" rather
			 than "except $2: pass". */
		      if (minify)
			output("except:%s\n", (yyvsp[-2].opt_string));
		      else
			output("except:\n%s%s\n", indent_string, (yyvsp[-2].opt_string));
		    }

		    free((yyvsp[-2].opt_string));
		  }
		  else {
		    if (minify)
		      output("except:%s\n", *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		    else
		      output("except:\n%s%s\n",
			     indent_string, *(yyvsp[-1].opt_string) ? (yyvsp[-1].opt_string) : "pass");
		  }

		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 2807 "parse.c" /* yacc.c:1652  */
    break;

  case 72:
#line 1025 "parse.y" /* yacc.c:1652  */
    {
		  if (*(yyvsp[-1].opt_string)) {
		    output("except %s:\n", (yyvsp[-1].opt_string));
		    free((yyvsp[-1].opt_string));
		  }
		  else {
		    output("except:\n");
		  }

		  increment(indent_count);
		}
#line 2823 "parse.c" /* yacc.c:1652  */
    break;

  case 73:
#line 1038 "parse.y" /* yacc.c:1652  */
    {
		  /* Let the symbol that uses block_start increment
		     indent_count so it can print things unindented
		     (e.g. func_def) */
		  /* Tell output() to wait for the whole block */
		  increment(wait_string);

		  /* Set `empty_block' so we remember to output "pass"
		     if the block is empty. */
		  next_empty();
		}
#line 2839 "parse.c" /* yacc.c:1652  */
    break;

  case 74:
#line 1051 "parse.y" /* yacc.c:1652  */
    {
		  /* This is for while loops translated from c-like
		     for loops */
		  if (while_end_expr && while_indent_count->count == indent_count) {
		    output("%s\n", while_end_expr->str);

		    free(while_end_expr->str);
		    list_free(while_end_expr, struct str_list);
		    list_free(while_indent_count, struct indent_count);
		  }
		  /* Output "pass" if the block was empty. */
		  else if (empty_block && empty_block->data) {
		    output("pass\n");
		  }

		  /* Pop the last `empty_block'. */
		  pop_empty();

		  decrement(wait_string);
		  decrement(indent_count);

		  /* Check if we're inside a `switch' block. If so,
		     decrement `switch_count' and decrement
		     `indent_count' an extra time since we're in
		     another block (the initial `if False' or a
		     case/default statement) which is not ended with a
		     `block_end'. */
		  if (switch_indent_count &&
		      switch_indent_count->count == indent_count - 1) {
		    /* Break out of the `while True' for the switch. */
		    if (!minify)
		      /* Separate the `break' if we're not minifying. */
		      output("\n");
		    output("break\n");
		    
		    decrement(indent_count);
		    decrement(switch_count);

		    /* Clean up the temporary variables */
		    output("del __c2py_switch_%u\n", switch_count);
		    output("del __c2py_switch_val_%u\n", switch_count);

		    /* Output "pass" if the last block BEFORE the
		       `switch' statement was empty. (I know, it's
		       confusing, I hardly understand it myself! Tell
		       the Python developers to add a `switch'
		       statement to Python!)

		       I don't think this is necessary anymore, but
		       I'll keep it (commented out) just in case. */
		    /*
		    if (empty_block && empty_block->data)
		      output("pass\n");
		    */

		    /* Pop the last `empty_block' AGAIN (it seems like
		       the right thing to do, I hope). */
		    pop_empty();
		    
		    /* Pop switch_indent_count */
		    list_free(switch_indent_count, struct indent_count);
		  }

		  if (backtrace && backtrace->indent_count == indent_count) {
		    /* Pop the backtrace. */
		    free(backtrace->name);
		    if (backtrace->prev) {
		      backtrace = backtrace->prev;
		      free(backtrace->next);
		      backtrace->next = NULL;
		    }
		    else {
		      free(backtrace);
		      backtrace = NULL;
		    }
		  }
		  
  #ifdef HAVE_LIBPYTHON
		  /* This will cause output() to run the command since
		     we're done with the block. */
		  if (shebang && !wait_string)
		    output("");
  #endif
		}
#line 2928 "parse.c" /* yacc.c:1652  */
    break;

  case 75:
#line 1137 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "+"; }
#line 2934 "parse.c" /* yacc.c:1652  */
    break;

  case 76:
#line 1138 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "-"; }
#line 2940 "parse.c" /* yacc.c:1652  */
    break;

  case 77:
#line 1139 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "*"; }
#line 2946 "parse.c" /* yacc.c:1652  */
    break;

  case 78:
#line 1140 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "/"; }
#line 2952 "parse.c" /* yacc.c:1652  */
    break;

  case 79:
#line 1141 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "="; }
#line 2958 "parse.c" /* yacc.c:1652  */
    break;

  case 80:
#line 1142 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "<"; }
#line 2964 "parse.c" /* yacc.c:1652  */
    break;

  case 81:
#line 1143 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = ">"; }
#line 2970 "parse.c" /* yacc.c:1652  */
    break;

  case 82:
#line 1144 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "&"; }
#line 2976 "parse.c" /* yacc.c:1652  */
    break;

  case 83:
#line 1145 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "|"; }
#line 2982 "parse.c" /* yacc.c:1652  */
    break;

  case 84:
#line 1146 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "^"; }
#line 2988 "parse.c" /* yacc.c:1652  */
    break;

  case 85:
#line 1147 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "+="; }
#line 2994 "parse.c" /* yacc.c:1652  */
    break;

  case 86:
#line 1148 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "-="; }
#line 3000 "parse.c" /* yacc.c:1652  */
    break;

  case 87:
#line 1149 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "*="; }
#line 3006 "parse.c" /* yacc.c:1652  */
    break;

  case 88:
#line 1150 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "/="; }
#line 3012 "parse.c" /* yacc.c:1652  */
    break;

  case 89:
#line 1151 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "**"; }
#line 3018 "parse.c" /* yacc.c:1652  */
    break;

  case 90:
#line 1152 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "//"; }
#line 3024 "parse.c" /* yacc.c:1652  */
    break;

  case 91:
#line 1153 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "<="; }
#line 3030 "parse.c" /* yacc.c:1652  */
    break;

  case 92:
#line 1154 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = ">="; }
#line 3036 "parse.c" /* yacc.c:1652  */
    break;

  case 93:
#line 1155 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "!="; }
#line 3042 "parse.c" /* yacc.c:1652  */
    break;

  case 94:
#line 1156 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "=="; }
#line 3048 "parse.c" /* yacc.c:1652  */
    break;

  case 95:
#line 1157 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "and"; }
#line 3054 "parse.c" /* yacc.c:1652  */
    break;

  case 96:
#line 1158 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "or"; }
#line 3060 "parse.c" /* yacc.c:1652  */
    break;

  case 97:
#line 1161 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "+"; }
#line 3066 "parse.c" /* yacc.c:1652  */
    break;

  case 98:
#line 1162 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "-"; }
#line 3072 "parse.c" /* yacc.c:1652  */
    break;

  case 99:
#line 1165 "parse.y" /* yacc.c:1652  */
    { (yyval.static_string) = "."; }
#line 3078 "parse.c" /* yacc.c:1652  */
    break;

  case 101:
#line 1170 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string)) + 2);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s.%s", (yyvsp[-2].string), (yyvsp[0].string));

		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3092 "parse.c" /* yacc.c:1652  */
    break;

  case 102:
#line 1182 "parse.y" /* yacc.c:1652  */
    { (yyval.opt_string) = ""; }
#line 3098 "parse.c" /* yacc.c:1652  */
    break;

  case 103:
#line 1183 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.opt_string)) * (strlen((yyvsp[0].string)) + 7);

		  (yyval.opt_string) = malloc(size);
		  /* Put a space before the `from' so we don't have to
		     check if it's empty */
		  snprintf((yyval.opt_string), size, " from %s", (yyvsp[0].string));

		  free((yyvsp[0].string));
		}
#line 3113 "parse.c" /* yacc.c:1652  */
    break;

  case 106:
#line 1198 "parse.y" /* yacc.c:1652  */
    { (yyval.opt_string) = ""; }
#line 3119 "parse.c" /* yacc.c:1652  */
    break;

  case 107:
#line 1201 "parse.y" /* yacc.c:1652  */
    { (yyval.opt_string) = (yyvsp[0].string); }
#line 3125 "parse.c" /* yacc.c:1652  */
    break;

  case 110:
#line 1208 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-1].opt_string)) + 3);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "[%s]", (yyvsp[-1].opt_string));

		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 3138 "parse.c" /* yacc.c:1652  */
    break;

  case 111:
#line 1217 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-1].opt_string)) + 3);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "(%s)", (yyvsp[-1].opt_string));

		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 3151 "parse.c" /* yacc.c:1652  */
    break;

  case 112:
#line 1226 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-3].string)) + strlen((yyvsp[-1].string)) + 3);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s[%s]", (yyvsp[-3].string), (yyvsp[-1].string));

		  free((yyvsp[-3].string));
		  free((yyvsp[-1].string));
		}
#line 3165 "parse.c" /* yacc.c:1652  */
    break;

  case 113:
#line 1236 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-1].string)) + strlen((yyvsp[0].string)) + (minify ? 4 : 6));

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, minify ? "%s=%s()" : "%s = %s()",
			   (yyvsp[0].string), (yyvsp[-1].string));

		  free((yyvsp[-1].string));
		  free((yyvsp[0].string));
		}
#line 3181 "parse.c" /* yacc.c:1652  */
    break;

  case 114:
#line 1250 "parse.y" /* yacc.c:1652  */
    {
		  /* 5 for "del \0" */
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[0].string)) + 5);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "del %s", (yyvsp[0].string));

		  free((yyvsp[0].string));
		}
#line 3195 "parse.c" /* yacc.c:1652  */
    break;

  case 115:
#line 1259 "parse.y" /* yacc.c:1652  */
    {
		  /* 7 for "return" + '\0' and 1 for a possible
		     space */
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[0].opt_string)) + 7 + !!*(yyvsp[0].opt_string));

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "return%s%s", *(yyvsp[0].opt_string) ? " " : "", (yyvsp[0].opt_string));

		  if (*(yyvsp[0].opt_string)) free((yyvsp[0].opt_string));
		}
#line 3210 "parse.c" /* yacc.c:1652  */
    break;

  case 116:
#line 1269 "parse.y" /* yacc.c:1652  */
    {
		  /* 8 for "global \0" */
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[0].string)) + 8);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "global %s", (yyvsp[0].string));

		  free((yyvsp[0].string));
		}
#line 3224 "parse.c" /* yacc.c:1652  */
    break;

  case 117:
#line 1279 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * 6;

		  /* Even though we could statically allocate it
		     (i.e. $$ = "raise"), we need to dynamically
		     allocate it so the destructor will handle it
		     properly */
		  (yyval.string) = malloc(size);
		  /* This makes GCC warn about "specified bound 5
		     equals source length" for some reason. I'm not
		     sure why that's a problem, but I guess we'll use
		     strcat instead (since there's really no point in
		     using strncat(3) if we pass a size of `size'
		     since it can write up to `size + 1' bytes to
		     `$$'). */
		  /* strncat($$, "raise", size - 1); */
		  strcat((yyval.string), "raise");
		}
#line 3247 "parse.c" /* yacc.c:1652  */
    break;

  case 118:
#line 1297 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-1].string)) + strlen((yyvsp[0].opt_string)) + 7);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "raise %s%s", (yyvsp[-1].string), (yyvsp[0].opt_string));

		  free((yyvsp[-1].string));
		  if (*(yyvsp[0].opt_string)) free((yyvsp[0].opt_string));
		}
#line 3261 "parse.c" /* yacc.c:1652  */
    break;

  case 119:
#line 1307 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-1].string)) + 3);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "(%s)", (yyvsp[-1].string));

		  free((yyvsp[-1].string));
		}
#line 3274 "parse.c" /* yacc.c:1652  */
    break;

  case 120:
#line 1316 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-3].string)) + strlen((yyvsp[-1].opt_string)) + 3);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s(%s)", (yyvsp[-3].string), (yyvsp[-1].opt_string));

		  free((yyvsp[-3].string));
		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 3288 "parse.c" /* yacc.c:1652  */
    break;

  case 121:
#line 1326 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string)) + 2);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s.%s", (yyvsp[-2].string), (yyvsp[0].string));

		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3302 "parse.c" /* yacc.c:1652  */
    break;

  case 122:
#line 1336 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-5].string)) + strlen((yyvsp[-3].string)) + strlen((yyvsp[-1].opt_string)) + 4);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s.%s(%s)", (yyvsp[-5].string), (yyvsp[-3].string), (yyvsp[-1].opt_string));

		  free((yyvsp[-5].string));
		  free((yyvsp[-3].string));
		  if (*(yyvsp[-1].opt_string)) free((yyvsp[-1].opt_string));
		}
#line 3318 "parse.c" /* yacc.c:1652  */
    break;

  case 123:
#line 1348 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-2].string)) + strlen((yyvsp[-1].static_string)) + strlen((yyvsp[0].string))
		     + ((minify && !isalpha((yyvsp[-1].static_string)[0])) ? 1 : 3));

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, (minify && !isalpha((yyvsp[-1].static_string)[0])) ?
			   "%s%s%s" : "%s %s %s", (yyvsp[-2].string), (yyvsp[-1].static_string), (yyvsp[0].string));

		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3335 "parse.c" /* yacc.c:1652  */
    break;

  case 124:
#line 1361 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[0].string)) + 2);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%c%s", *(yyvsp[-1].static_string), (yyvsp[0].string));

		  free((yyvsp[0].string));
		}
#line 3348 "parse.c" /* yacc.c:1652  */
    break;

  case 125:
#line 1369 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string)) + 5);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s in %s", (yyvsp[-2].string), (yyvsp[0].string));

		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3362 "parse.c" /* yacc.c:1652  */
    break;

  case 126:
#line 1379 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-3].string)) + strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string))
		     + (minify ? 4 : 6));

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, minify ? "%s=%s(%s)" : "%s = %s(%s)",
			   (yyvsp[-2].string), (yyvsp[-3].string), (yyvsp[0].string));

		  free((yyvsp[-3].string));
		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3380 "parse.c" /* yacc.c:1652  */
    break;

  case 127:
#line 1393 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-4].string)) + strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string)) + 11);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "%s if %s else %s", (yyvsp[-2].string), (yyvsp[-4].string), (yyvsp[0].string));

		  free((yyvsp[-4].string));
		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3396 "parse.c" /* yacc.c:1652  */
    break;

  case 128:
#line 1405 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) * (strlen((yyvsp[0].string)) + 5);

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, "not %s", (yyvsp[0].string));

		  free((yyvsp[0].string));
		}
#line 3409 "parse.c" /* yacc.c:1652  */
    break;

  case 129:
#line 1417 "parse.y" /* yacc.c:1652  */
    { (yyval.opt_string) = ""; }
#line 3415 "parse.c" /* yacc.c:1652  */
    break;

  case 130:
#line 1420 "parse.y" /* yacc.c:1652  */
    { (yyval.opt_string) = (yyvsp[0].string); }
#line 3421 "parse.c" /* yacc.c:1652  */
    break;

  case 131:
#line 1428 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.opt_string)) * (strlen((yyvsp[-1].string)) + 2);

		  (yyval.opt_string) = malloc(size);
		  snprintf((yyval.opt_string), size, "%s,", (yyvsp[-1].string));

		  free((yyvsp[-1].string));
		}
#line 3434 "parse.c" /* yacc.c:1652  */
    break;

  case 133:
#line 1439 "parse.y" /* yacc.c:1652  */
    {
		  size_t size = sizeof(*(yyval.string)) *
		    (strlen((yyvsp[-2].string)) + strlen((yyvsp[0].string)) + (minify ? 2 : 3));

		  (yyval.string) = malloc(size);
		  snprintf((yyval.string), size, minify ? "%s,%s" : "%s, %s", (yyvsp[-2].string), (yyvsp[0].string));

		  free((yyvsp[-2].string));
		  free((yyvsp[0].string));
		}
#line 3449 "parse.c" /* yacc.c:1652  */
    break;

  case 134:
#line 1452 "parse.y" /* yacc.c:1652  */
    {
		  if (!interactive)
		    YYABORT;
		}
#line 3458 "parse.c" /* yacc.c:1652  */
    break;


#line 3462 "parse.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1458 "parse.y" /* yacc.c:1918  */


/* We have to put this in the epilogue so we can use the token macros */
static const struct {char *str; int token;} multi_char_tokens[] =
  {
   {"import",  IMPORT },
   {"from",    FROM   },
   {"as",      AS     },
   {"for",     FOR    },
   {"do",      DO     },
   {"while",   WHILE  },
   {"in",      IN     },
   {"if",      IF     },
   {"elif",    ELIF   },
   {"else",    ELSE   },
   {"switch",  SWITCH },
   {"case",    CASE   },
   {"default", DEFAULT},
   {"try",     TRY    },
   {"except",  EXCEPT },
   {"finally", FINALLY},
   {"raise",   RAISE  },
   {"del",     DEL    },
   {"global",  GLOBAL },
   {"class",   CLASS  },
   {"return",  RETURN }
  };

static void yyerror(const char *message) {
  fprintf(stderr, "%s:%u:%u", *input_file_names, last_line, last_column);

  if (backtrace) {
    /* Save the `backtrace' because we will overwrite it. */
    struct backtrace *backtrace_save = backtrace;
    
    /* Go to the beginning of `backtrace' and print it from there to
       be more like Python's "traceback"s (most recent call last). */
    while (backtrace->prev)
      backtrace = backtrace->prev;
    
    /* Print the backtrace. */
    while (backtrace) {
      fprintf(stderr, "\n%u:%u in %s %s", backtrace->line, backtrace->column,
	      (backtrace->type == class) ? "class" :
	      (backtrace->type == func) ? "function" : "method",
	      backtrace->name);
      
      backtrace = backtrace->next;
    }

    /* Restore the backtrace. */
    backtrace = backtrace_save;

    /* Now print the error message. */
    fprintf(stderr, "\n%s\n", message);
  }
  else {
    /* No need for a newline since we didn't print a backtrace. */
    fprintf(stderr, ": %s\n", message);
  }

#ifdef ENABLE_POLYRUN
  /* Print a sorry message if polyrun is installed (see polyrun(1) and
     polygen(1)). */
  system("polyrun sorry >&2 2> /dev/null");
#endif
}

/* Check if a character in a linked list of characters is escaped */
static int escaped(const llist_t *chars) {
  int is_escaped = 0;

  /* Check if the character is escaped */
  for (chars = chars->prev; chars && chars->data == '\\'; chars = chars->prev)
    is_escaped = !is_escaped;

  return is_escaped;
}

/* Check if a character in a string (not a linked list) is escaped */
static int escaped_str(const char *str, int index) {
  int is_escaped = 0;

  /* Check if the character is escaped */
  for (int i = index - 1; i >= 0 && str[i] == '\\'; i--)
    is_escaped = !is_escaped;

  return is_escaped;
}

static int yylex(void) {
  int c, d;
  llist_t *input_chars = NULL;
  char quote = 0, mline_quote = 0;

  /* Skip white space and comments. */
  while (1) {
    d = 0;

    while (isspace(c = get_input())) {
      /* Update location in file. */
      if (c == '\n') {
	/* Save the column in case we unget_input() c. */
	column_save = column;
	column = 0;
	line++;
      }
      else {
	column++;
      }
      
      if (!minify) {
	if (c == '\n' && d == '\n')
	  output("\n");

	d = c;
      }
    }

    if (c == EOF) {
      /* Make sure that all {'s are matched. */
      if (indent_count) {
	yyerror("syntax error, unmatched `{'");
	return YYLEX_ERROR;
      }
      
      return 0;
    }

    /* Update location in file. */
    if (c == '\n') {
      column_save = column; /* Save the column in case we unget_input() c. */
      column = 0;
      line++;
    }
    else {
      column++;
    }
      
    last_line = line;
    last_column = column;

    /* Skip comments. Note that we can't use // since that is used for
       integer division. */
    /* Multi-line comment. */
    if (c == '/') {
      d = c;
      c = get_input();

      if (c == EOF)
	return '/';
      
      /* Update location in file. */
      if (c == '\n') {
	/* Save the column in case we unget_input() c. */
	column_save = column;
	column = 0;
	line++;
      }
      else {
	column++;
      }

      if (c == '/') {
	/* Integer division */
	unget_input(c);
	/* `c' already is `d', so we need not set it */

	break;
      }

      /* It is a multi-line comment */
      if (c == '*') {
	/* Make the prompt use sys.ps2 if we're in interactive mode */
	if (interactive) yylex_increment(wait_string);

	if (!minify)
	  output("#");

	while (1) {
	  d = c;
	  c = get_input();

	  /* Check for EOF. */
	  if (c == EOF) {
	    yyerror("syntax error, unterminated comment");

	    return YYLEX_ERROR;
	  }

	  /* Update location in file. */
	  if (c == '\n') {
	    /* Save the column in case we unget_input() c. */
	    column_save = column;
	    column = 0;
	    line++;
	  }
	  else {
	    column++;
	  }
      
	  /* Check for the end of the comment. */
	  if (c == '*') {
	    d = c;
	    c = get_input();

	    /* Check for EOF. */
	    if (c == EOF) {
	      yyerror("syntax error, unterminated comment");

	      return YYLEX_ERROR;
	    }

	    /* Update location in file. */
	    if (c == '\n') {
	      /* Save the column in case we unget_input() c. */
	      column_save = column;
	      column = 0;
	      line++;
	    }
	    else {
	      column++;
	    }
      
	    if (c == '/') {
	      break;
	    }
	    else {
	      unget_input(c);

	      /* Update location in file. */
	      if (c == '\n') {
		column = column_save;
		line--;
	      }
	      else {
		column--;
	      }
      
	      c = d;
	    }
	  }

	  /* We haven't reached the end yet. */
	  if (!minify) {
	    output_no_indent = 1;
	    output("%c", c);
	    output_no_indent = 0;
	    
	    if (c == '\n') {
	      output("#");
	    }
	  }
	}

	if (!minify)
	  output("\n");

	/* Decrement `wait_string' if we incremented it for the
	   prompt */
	if (interactive) yylex_decrement(wait_string);
      }
      else {
	unget_input(c);

	/* Update location in file. */
	if (c == '\n') {
	  column = column_save;
	  line--;
	}
	else {
	  column--;
	}
      
	c = d;
      }
    }
    /* Single-line comment. EOF's are ok for single line comments
       because a single line comment without a '\n' at the end of a
       file is legitimate. */
    else if (c == '#') {
      /* Indent it correctly. */
      if (!minify)
	output("#");
      
      do {
	c = get_input();

	if (c != EOF) {
	  /* Update location in file. */
	  if (c == '\n') {
	    /* Save the column in case we unget_input() c. */
	    column_save = column;
	    column = 0;
	    line++;
	  }
	  else {
	    column++;
	  }
      
	  if (!minify) {
	    output_no_indent = 1;
	    output("%c", c);
	    output_no_indent = 0;
	  }
	}
      } while (c != '\n' && c != EOF);

      if (c != EOF) {
	unget_input(c);

	/* Update location in file. */
	if (c == '\n') {
	  column = column_save;
	  line--;
	}
	else {
	  column--;
	}
      }
    }
    else {
      break;
    }
  }

  if (strchr(TOKEN_STRING, c)) {
    d = get_input();

    if (d == EOF) {
      return c;
    }
      
    /* Update location in file. */
    if (d == '\n') {
      column_save = column; /* Save the column in case we unget_input() c. */
      column = 0;
      line++;
    }
    else {
      column++;
    }
      
    /* Check for ==, +=, etc. */
    switch (c) {
    case '!':
      if (d == '=')
	return NOT_EQUAL;
      break;
    case '&':
      if (d == '&')
	return BOOL_AND;
      break;
    case '|':
      if (d == '|')
	return BOOL_OR;
      break;
    case '=':
      if (d == '=')
	return EQUAL;
      break;
    case '<':
      if (d == '=')
	return LESS_EQ;
      break;
    case '>':
      if (d == '=')
	return GREATER_EQ;
      break;
    case '+':
      switch (d) {
      case '=':
	return PLUS_EQ;
      case '+':
	/* Make `++' behave like `+= 1' */
	unget_input('1');

	/* Make sure we don't mess up the location. */
	column--;
      
	return PLUS_EQ;
      }
      break;
    case '-':
      switch (d) {
      case '=':
	return MINUS_EQ;
      case '-':
	/* Make `--' behave like `-= 1' */
	unget_input('1');

	/* Make sure we don't mess up the location. */
	column--;
      
	return MINUS_EQ;
      }
      break;
    case '*':
      switch (d) {
      case '=':
	return MUL_EQ;
      case '*':
	return POWER;
      }
      break;
    case '/':
      switch (d) {
      case '=':
	return DIV_EQ;
      case '/':
	return INT_DIV;
      }
      break;
    }

    unget_input(d);

    /* Update location in file. */
    if (d == '\n') {
      column = column_save;
      line--;
    }
    else {
      column--;
    }
      
    return c;
  }

  /* Check if we're quoted. */
  if (strchr(QUOTE_CHARS, c))
    quote = c;

  llist_create(input_chars);

  /* Get the input string */
  do {
    /* If c is '\0' (not EOF), that means the user was trying to
       confuse us. Obviously, the user mistook us for your average
       dumb program. We are smarter than that but still, not cool. */
    if (!c) {
      fputs("Hey! That's not nice! :(\n", stderr);
      llist_destroy(input_chars);

      return YYLEX_ERROR;
    }

    if (c == quote && input_chars->prev) {
      if (input_chars->prev->prev) {
	if (input_chars->prev->data == quote &&
	    input_chars->prev->prev->data == quote &&
	    !escaped(input_chars->prev->prev)) {
	  if (mline_quote) {
	    /* We're ending a triple-quoted string literal */

	    /* Decrement `wait_string' if we incremented it for the
	       prompt */
	    if (interactive) yylex_decrement(wait_string);

	    break;
	  }

	  /* We're starting a triple-quoted string literal */

	  /* Make the prompt use sys.ps2 if we're in interactive
	     mode */
	  if (interactive) yylex_increment(wait_string);

	  mline_quote = 1;

	  /* Handle empty multi-line string literals. */
	  input_chars->data = c;
	  llist_add_forward(input_chars);
	  llist_next(input_chars);

	  c = get_input();

	  if (c != EOF) {
	    /* Update location in file. */
	    if (c == '\n') {
	      /* Save the column in case we unget_input() c. */
	      column_save = column;
	      column = 0;
	      line++;
	    }
	    else {
	      column++;
	    }
	  }
      
	  if (c == quote) {
	    c = get_input();

	    if (c != EOF) {
	      /* Update location in file. */
	      if (c == '\n') {
		/* Save the column in case we unget_input() c. */
		column_save = column;
		column = 0;
		line++;
	      }
	      else {
		column++;
	      }
	    }
      
	    input_chars->data = c;
	    llist_add_forward(input_chars);
	    llist_next(input_chars);
	    
	    if (c == quote) {
	      c = get_input();

	      if (c != EOF) {
		/* Update location in file. */
		if (c == '\n') {
		  /* Save the column in case we unget_input() c. */
		  column_save = column;
		  column = 0;
		  line++;
		}
		else {
		  column++;
		}
	      }
      
	      input_chars->data = c;
	      llist_add_forward(input_chars);
	      llist_next(input_chars);
	    
	      if (c == quote) {
		break;
	      }
	    }
	  }
	}

	/* Break if we're ending a single line string literal */
	if (!mline_quote && !escaped(input_chars))
	  break;
      }
      /* Handle empty single-line string literals. */
      else if (input_chars->prev->data == quote) {
	unget_input(c = get_input());

	if (c == EOF) {
	  yyerror("syntax error, unexpected EOF when scanning string literal");
	  llist_destroy(input_chars);

	  return YYLEX_ERROR;
	}

	if (c != quote) {
	  c = quote;

	  break;
	}

	c = quote;
      }
    }

    input_chars->data = c;
    llist_add_forward(input_chars);
    llist_next(input_chars);

    c = get_input();

    /* Update location in file. */
    if (c == '\n') {
      column_save = column; /* Save the column in case we unget_input() c. */
      column = 0;
      line++;
    }
    else {
      column++;
    }
      
    if (quote) {
      if (c == EOF) {
	if (mline_quote)
	  yyerror("syntax error, unexpected end of file "
		  "when scanning triple-quoted string literal");
	else
	  yyerror("syntax error, unexpected end of "
		  "file when scanning string literal");

	llist_destroy(input_chars);

	return YYLEX_ERROR;
      }
      else if (c == '\n' && !escaped(input_chars) && !mline_quote) {
	yyerror("syntax error, unexpected end of "
		"line when scanning string literal");
	llist_destroy(input_chars);
	
	return YYLEX_ERROR;
      }
    }
  } while (quote || (c != EOF && !isspace(c) &&
		      !strchr(TOKEN_STRING QUOTE_CHARS, c)));

  /* Add the quote character. */
  if (quote) {
    input_chars->data = c;
    llist_add_forward(input_chars);
    llist_next(input_chars);
  }
  /* Make sure we catch one-character tokens such as '(', ')', ',',
     and ';'. */
  else if (c != EOF && !isspace(c)) {
    unget_input(c);

    /* Update location in file. */
    if (c == '\n') {
      column = column_save;
      line--;
    }
    else {
      column--;
    }
      
    c = quote;
  }

  /* Convert the list to a string. */
  yylval.string = llist_to_array(input_chars);

  /* Free the list. */
  llist_destroy(input_chars);

  /* Check if the string is a multi-character token unless it's a
     string literal. */
  if (!quote) {
    for (int i = 0;
	 i < sizeof(multi_char_tokens) / sizeof(*multi_char_tokens); i++) {
      if (!strcmp(yylval.string, multi_char_tokens[i].str)) {
	free(yylval.string);
	yylval.string = NULL;

	return multi_char_tokens[i].token;
      }
    }
  }

  return quote ? STRING_LITERAL : STRING;
}

/* Initialize `quoted_pos' from a string

   FIXME: This is less efficient than it should be because we parse
   for quotes twice (once in yylex()) */
static void quoted_init(const char *str) {
  enum { none, single, Double, /* Capital D to distinguish from the
				  `double' type */
	 triple_single, triple_double } quote_type = none;
  size_t length = strlen(str);

  for (size_t i = 0; i < length; i++) {
    if ((str[i] == '\'' || str[i] == '"') && !escaped_str(str, i)) {
      if (quote_type == none) {
	/* Check if it's triple-quoted */
	if (i + 2 < length && str[i+1] == str[i] && str[i+2] == str[i])
	  quote_type = str[i] == '\'' ? triple_single : triple_double;
	else
	  quote_type = str[i] == '\'' ? single : Double;

	/* Add it to the list of quoted positions */
	list_add_new(quoted_pos, struct quoted_pos);
	quoted_pos->start = i;
      }
      /* Check if we're ending a quote */
      else if ((quote_type == single && str[i] == '\'') ||
	       (quote_type == Double && str[i] == '"') ||
	       (i + 2 < length &&
		((quote_type == triple_single &&
		  str[i] == '\'' && str[i+1] == '\'' && str[i+2] == '\'') ||
		 (quote_type == triple_double &&
		  str[i] == '"' && str[i+1] == '"' && str[i+2] == '"')))) {
	if (quote_type == triple_single || quote_type == triple_double)
	  quoted_pos->end = i + 2;
	else
	  quoted_pos->end = i;
      }
    }
  }
}

/* Check if `pos' is quoted (we shouldn't indent it) */
static int quoted(size_t pos) {
  /* The position we are currently checking */
  struct quoted_pos *quoted_pos_cur = quoted_pos;

  while (quoted_pos_cur) {
    if (pos >= quoted_pos_cur->start && pos <= quoted_pos_cur->end)
      return 1;

    quoted_pos_cur = quoted_pos_cur->prev;
  }

  /* If we get here, `pos' wasn't quoted */
  return 0;
}

/* This is used in indent() */
#define _indent_add_char(c) do {		\
    if (indent_str && index) {			\
      indent_str[(*index)++] = (c);		\
    }						\
    else {					\
      if (putc((c), output_file) == EOF)	\
	return -1;				\
    }						\
  } while (0)

/* Indent a string, returning the number of spaces added */
static int indent(const char *str, char *indent_str,
		  size_t size, size_t *index) {
  int ret = 0;

  for (size_t i = 0; i < size; i++) {
    /* If i == 0, we want to indent first. Wait until after we indent
       it. */
    if (i)
      _indent_add_char(str[i]);

    /* We should only indent it if there is a newline if the newline
       is not the end of the string. This is because following calls
       to output() will add to the indent and not indent correctly. We
       also should not indent if we are inside a quoted string. */
    if (!i || (i != size - 1 && str[i] == '\n' && !quoted(i))) {
      /* Now add the correct number of spaces. */
      for (int j = 0; j < indent_count * indent_size; j++) {
	_indent_add_char(' ');
	ret++;
      }
    }

    /* Now copy the character if we hadn't before. */
    if (!i)
      _indent_add_char(str[i]);
  }

  /* Add the '\0' if we're outputing to a string */
  if (indent_str && index)
    indent_str[*index] = '\0';

  return ret;
}

/* Output the string to output_file or run it with the embedded
   interpreter if available, preceding with the appropriate
   indenting */
#ifndef HAVE_LIBPYTHON
/* get_input() does not use output() if we're not compiled with
   libreadline. */
static
#endif
int output(const char *format, ...) {
  int size;
  char *str = NULL, *do_str_run = NULL;
  size_t do_str_run_size = 0;
  int ret;
  va_list ap;
  static unsigned int do_str_count = 0;
  static struct str_size_list {
    struct str_size_list *prev;
    char *str;
    size_t size, index;
  } *do_str = NULL;

  /* Determine size of string (vsnprintf() returns the number of bytes
     that WOULD have been returned if it was not truncated. So we can
     use it with a size of 0 to see how much we should allocate.) */
  va_start(ap, format);
  size = vsnprintf(NULL, 0, format, ap);
  va_end(ap); /* You cannot reuse `ap' (I learned that the hard way). */

  /* Check for errors. */
  if (size < 0)
    return size;

  size++; /* For '\0' */

  /* Allocate and set the string. */
  if (!(str = malloc(size)))
    return -1;

  va_start(ap, format);
  ret = vsnprintf(str, size, format, ap);
  va_end(ap);

  /* This should not happen, but check for it anyway. */
  if (ret >= size)
    ret = size - 1;

  /* We don't need `size' anymore. We do, however, need the length of
     the string minus the terminating '\0' which just happens to be
     `ret'. However, since we are going to change `ret', we can set
     `size' to `ret' and use that instead. */
  size = ret;

  /* Parse the string for quotes */
  quoted_init(str);

  /* Add a new member to `do_str' if we need to */
  if (do_str_count < do_count) {
    do_str_count++;
    list_add_new(do_str, struct str_size_list);
    do_str->str = NULL;
    do_str->size = 1; // 1 for the terminating '\0'
    do_str->index = 0;
  }
  else if (do_str_count > do_count) {
    do_str_run = do_str->str;
    do_str_run_size = do_str->size - 1;

    do_str_count--;
    list_free(do_str, struct str_size_list);
  }
  assert(do_str_count == do_count);

  /* Add the string to the current `do_str' if we need to */
  if (do_str) {
    /* Calculate the size of the string */
    do_str->size += size + do_str_run_size;

    if (!output_no_indent) {
      for (char *pos = str; pos && *pos;) {
	if (!quoted((pos - str) / sizeof(*pos)))
	  do_str->size += indent_count * indent_size;

	if ((pos = strchr(pos, '\n'))) pos++;
      }
    }

    if (!(do_str->str =
	  realloc(do_str->str, sizeof(*(do_str->str)) * do_str->size)))
      return -1;

    if (output_no_indent) {
      strncat(do_str->str, str, size);
      do_str->index += size;
    }
    else {
      ret += indent(str, do_str->str, size, &(do_str->index));
    }

    if (do_str_run) {
      /* Add `do_str_run' */
      strncat(do_str->str, do_str_run, do_str_run_size);
      do_str->index += do_str_run_size;
    }
  }
#ifdef HAVE_LIBPYTHON
  else if (shebang) {
    static char *exec_str = NULL; // The string to execute
    static size_t exec_str_size = 1; // 1 for the terminating '\0'
    static size_t index = 0;

    /* Calculate the size of the string */
    exec_str_size += size + do_str_run_size;

    if (!output_no_indent) {
      for (char *pos = str; pos && *pos;) {
	if (!quoted((pos - str) / sizeof(*pos)))
	  exec_str_size += indent_count * indent_size;

	if ((pos = strchr(pos, '\n'))) pos++;
      }
    }

    if (!(exec_str = realloc(exec_str, sizeof(*exec_str) * exec_str_size))) {
      free(str);
      return -1;
    }

    if (output_no_indent) {
      strncat(exec_str, str, size);
      index += size;
    }
    else {
      /* Now copy `str' to `exec_str' but indent correctly. We can
	 safely assume that indent() did not return -1, because it
	 only does that when outputting to `output_file'. */
      ret += indent(str, exec_str, size, &index);
    }

    if (do_str_run) {
      /* Add `do_str_run' */
      strncat(exec_str, do_str_run, do_str_run_size);
      index += do_str_run_size;
    }

    /* Run the string if it's not the start of a block ("if foo:\n"
       for example) and it's not part of a block. This is because we
       need to run the whole block at the same time ("if foo:\n
       bar()\n") so PyRun_String() doesn't complain about an
       unexpected EOF. */
    if (!wait_string) {
      PyObject *pymain, *pyvars, *pyret;
      int error_occured = 0;
      
      assert(index == exec_str_size - 1);

      exec_str[index] = '\0';

      /* Get a reference to the __main__ module and get the variables
	 for `globals' and `locals' to pass to PyRun_String(). */
      if (!(pymain = PyImport_AddModule("__main__")) ||
	  !(pyvars = PyModule_GetDict(pymain))) {
	error_occured = 1;
      }
      /* Now run the string if it's not empty */
      else if (*exec_str) {
	if (!(pyret = PyRun_String(exec_str, interactive ?
				   Py_single_input : Py_file_input,
				   pyvars, pyvars))) {
	  PyErr_Print();
	
	  if (!interactive)
	    exit(1);
	}
	else {
	  Py_DECREF(pyret);
	}
      }

      /* Reset the static variables. */
      free(exec_str);
      exec_str = NULL;
      exec_str_size = 1;
      index = 0;

      /* Check if an error occured. */
      if (error_occured) {
	free(str);

	if (!interactive)
	  exit(1);

# ifdef HAVE_LIBREADLINE
	return -1;
# endif
      }
    }
  }
#endif /* HAVE_LIBPYTHON */
  else {
    /* Now print the string to the output file, indenting
       correctly if needed. */
    if (output_no_indent) {
      if (fputs(str, output_file) == EOF)
	return -1;
    }
    else {
      int tmp;

      if ((tmp = indent(str, NULL, size, NULL)) == -1) {
	if (do_str_run) free(do_str_run);
	return -1;
      }

      ret += tmp;
    }

    /* Print `do_str_run' */
    if (do_str_run && fputs(do_str_run, output_file) == EOF) {
      free(do_str_run);
      return -1;
    }
  }

  if (do_str_run) free(do_str_run);

  /* Free the list of quoted positions */
  while (quoted_pos)
    list_free(quoted_pos, struct quoted_pos);

  free(str);

  return ret;
}
